Subject: Re: [PATCH RFC net-next v2 1/2] net: phy: marvell: 88e1111: define gigabit features

From: "Russell King (Oracle)" <[email-masked]>
Date: Mon, 19 Jan 2026 10:52:17 +0000

On Mon, Jan 19, 2026 at 08:30:12AM +0000, Josua Mayer wrote:
> Hi Russell,
> 
> Thank you for the extensive feedback!
> 
> On 02/01/2026 15:55, Russell King (Oracle) wrote:
> > On Fri, Jan 02, 2026 at 12:47:06PM +0000, Russell King (Oracle) wrote:
> >> I do have patches that add phydev->supported_interfaces which are
> >> populated at probe time to inform phylink which host interface modes
> >> that the PHY can be reconfigured between - and this overrides the
> >> linkmode-derivation of that information - it basically becomes:
> >>
> >>          phy_interface_and(interfaces, phy->supported_interfaces,
> >>                            pl->config->supported_interfaces);
> >>          interface = phylink_choose_sfp_interface(pl, interfaces);
> >>          if (interface == PHY_INTERFACE_MODE_NA) {
> >>                  phylink_err(pl, "selection of interface for PHY failed\n");
> >>                  return -EINVAL;
> >>          }
> >>
> >>          phylink_dbg(pl, "copper SFP: chosen %s interface\n",
> >>                      phy_modes(interface));
> >>
> >>          ret = phylink_attach_phy(pl, phy, interface);
> >>
> >> and phylink_attach_phy() will result in the PHY driver's config_init
> >> being called, configuring the appropriate operating mode for the
> >> PHY, which can then be used to update phydev->supported as appropriate.
> >>
> >> phylink will then look at phydev->supported once the above has
> >> completed when it will do so in phylink_bringup_phy().
> >>
> >> Deriving the host side PHY interface mode from the link modes has
> >> always been rather sketchy.
> > These patches can be found at:
> >
> > http://git.armlinux.org.uk/cgit/linux-arm.git/log/?h=net-queue
> >
> > See:
> >
> > net: phylink: use phy interface mode bitmaps for SFP PHYs
> > net: phy: add supported_interfaces to Aquantia AQR113C
> > net: phy: add supported_interfaces to marvell10g PHYs
> > net: phy: add supported_interfaces to marvell PHYs
> > net: phy: add supported_interfaces to bcm84881
> > net: phy: add supported_interfaces to phylib
> >
> > The reason I didn't end up pushing them (they're almost six years old)
> > is because I decided that the host_interfaces approach wasn't a good
> > idea, and dropped those patches. Marek Behún took my patches for
> > host_interfaces and they were merged in 2022. I had already junked
> > the host_interfaces approach.
> >
> > The problem is that we now have two ways that PHY drivers configure
> > their interface mode - one where config_init() decides on its own
> > based on the host_interfaces supplied to it, and this approach above
> > where phylink attempts to choose the interface based on what the
> > PHY and host (and datapath) can support. These two approaches are
> > mutually incompatible if we get both phylink _and_ the PHY driver
> > attempting to do the same thing.
> 
> All this left me puzzled.
> 
> I understand that .features / get_features happens too early
> and doesn't account for different host interfaces.
> 
> Further populating supported bitmask before config_init is wrong
> at least for this module where supported link-modes are different
> per host interface.
> 
> The marvell10g.c driver which now uses the host_interfaces bitmask
> is now extending the supported_interfaces bitmask in config_init.
> Yet I didn't understand what it means.
> 
>  From phy.h:
> 
>   * @possible_interfaces: bitmap if interface modes that the attached PHY
>   *             will switch between depending on media speed.

Note, I said *supported* not *possible*. They're two different things.

The supported mask is the list of interfaces that the PHY has support
for e.g. 88x3310 can support 10GBASE-R, 5GBASE-R, 2500BASE-X, SGMII,
USXGMII, and a few others that I can't recall off the top of my head.
This needs to be known before attaching to the PHY to allow the
operating mode to be chosen.

The possible mask is "we've configured it for this operating mode,
now which of those interfaces will we switch between depending on the
media"

Both are the host side.

-- 
RMK's Patch system: https://www.armlinux.org.uk/developer/patches/
FTTP is here! 80Mbps down 10Mbps up. Decent connectivity at last!